import { IBitMatrix } from "./Interfaces/IBitMatrix";
export declare class BitMatrix implements IBitMatrix {
    private rowCount;
    private colCount;
    private buffer;
    constructor(rowSize: number, colSize: number);
    clone(): IBitMatrix;
    count(): number;
    get(rowIndex: number, colIndex: number): boolean;
    getColIndexes(column: number): number[];
    getRowIndexes(row: number): number[];
    getIndexes(resultPerColumn?: boolean): number[][];
    reset(): BitMatrix;
    resize(rowCount: number, colCount: number): BitMatrix;
    setBuffer(newBuffer: Uint32Array): IBitMatrix;
    size(): number[];
    spliceColumn(startIndex: number, deleteCount: number): IBitMatrix;
    spliceRow(startIndex: number, deleteCount: number): IBitMatrix;
    set(rowIndex: number, colIndex: number, value: boolean): this;
    private calculateBufferSize;
    private getBitPosition;
    private bitsCountInNumber;
    private validateIndex;
}
