(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./bubbleSort", "./gnomeSort", "./insertionSort", "./mergeSort", "./quickSort", "./selectionSort"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const bubbleSort_1 = require("./bubbleSort");
    const gnomeSort_1 = require("./gnomeSort");
    const insertionSort_1 = require("./insertionSort");
    const mergeSort_1 = require("./mergeSort");
    const quickSort_1 = require("./quickSort");
    const selectionSort_1 = require("./selectionSort");
    const Sort = {
        bubbleSort: bubbleSort_1.default,
        gnomeSort: gnomeSort_1.default,
        insertionSort: insertionSort_1.default,
        mergeSort: mergeSort_1.default,
        quickSort: quickSort_1.default,
        selectionSort: selectionSort_1.default
    };
    exports.default = Sort;
});
//# sourceMappingURL=index.js.map