(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../Utils"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const Utils_1 = require("../Utils");
    function insertionSort(array, comparator = Utils_1.Utils.gt, startIndex = 0, endIndex = -1) {
        if (!Array.isArray(array)) {
            return array;
        }
        if (endIndex === -1) {
            endIndex = array.length;
        }
        if ((endIndex - startIndex) < 2) {
            return array;
        }
        for (let j = startIndex + 1, length = endIndex; j < length; j++) {
            let key = array[j];
            let index = j - 1;
            while (index >= startIndex && comparator(array[index], key)) {
                array[index + 1] = array[index];
                index--;
            }
            array[index + 1] = key;
        }
        return array;
    }
    exports.default = insertionSort;
});
//# sourceMappingURL=insertionSort.js.map