(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    function mergeSort(array, reverse = false, startIndex, endIndex) {
        if (!Array.isArray(array)) {
            return array;
        }
        startIndex = startIndex === void 0 ? 0 : startIndex;
        endIndex = endIndex === void 0 ? array.length : endIndex;
        if (array.length < 2 || endIndex - startIndex < 2) {
            return array;
        }
        const middleIndex = startIndex + Math.floor((endIndex - startIndex) / 2);
        mergeSort(array, reverse, startIndex, middleIndex);
        mergeSort(array, reverse, middleIndex, endIndex);
        merge(array, reverse, startIndex, middleIndex, endIndex);
        return array;
    }
    function merge(array, reverse, startIndex, middleIndex, endIndex) {
        const left = array.slice(startIndex, middleIndex);
        const right = array.slice(middleIndex, endIndex);
        left.push(reverse ? -Infinity : Infinity);
        right.push(reverse ? -Infinity : Infinity);
        let i = 0;
        let j = 0;
        for (let k = startIndex; k < endIndex; k++) {
            if ((reverse && left[i] >= right[j]) || (!reverse && left[i] <= right[j])) {
                array[k] = left[i];
                i++;
            }
            else {
                array[k] = right[j];
                j++;
            }
        }
    }
    exports.default = mergeSort;
});
//# sourceMappingURL=mergeSort.js.map